/* $Xorg: syncstr.h,v 1.4 2001/02/09 02:03:24 xorgcvs Exp $ */
/*

Copyright 1991, 1993, 1994, 1998  The Open Group

Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation.

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
OPEN GROUP BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of The Open Group shall not be
used in advertising or otherwise to promote the sale, use or other dealings
in this Software without prior written authorization from The Open Group.

*/

/***********************************************************
Copyright 1991,1993 by Digital Equipment Corporation, Maynard, Massachusetts,
and Olivetti Research Limited, Cambridge, England.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or Olivetti
not be used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL AND OLIVETTI DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL THEY BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

******************************************************************/
/* $Id: syncint.h,v 3.2 2005-04-20 18:42:31 clee Exp $ */

#ifndef _SYNCINT_H_
#define _SYNCINT_H_

#include <X11/extensions/syncstr.h>

#define CARD64 XSyncValue /* XXX temporary! need real 64 bit values for Alpha */

/*
 * The System Counter interface
 */

typedef void
(*SyncQueryValueProcPtr) (pointer pCounter,
			  CARD64 *freshvalue);

typedef void
(*SyncBracketValuesProcPtr) (pointer pCounter,
			     CARD64 *lessthan,
			     CARD64 *greaterthan);

struct _SyncTrigger;

typedef Bool
(*SyncCheckTriggerProcPtr) (struct _SyncTrigger *pTrigger,
			    CARD64		newval);

typedef void
(*SyncTriggerFiredProcPtr)(struct _SyncTrigger *pTrigger);

typedef void
(*SyncCounterDestroyedProcPtr) (struct _SyncTrigger *pTrigger);

pointer
SyncCreateSystemCounter(char			    *name,
			CARD64			    inital_value,
			CARD64			    resolution,
			SyncCounterType		    change_characterization,
			SyncQueryValueProcPtr	    QueryValue,
			SyncBracketValuesProcPtr    BracketValues);

void
SyncChangeCounter(SyncCounter	*pCounter,
		  CARD64	new_value);

void
SyncDestroySystemCounter(pointer pCounter);

void
InitServertime(void);

#endif /* _SYNCINT_H_ */
